## celestia 1.7.0~git20250418+fab96cc

=== CMakeLists.txt ===
if(WIN32)
  # Require more recent CMake on Windows because DLLs are a pain
  cmake_minimum_required(VERSION 3.19)
else()
  cmake_minimum_required(VERSION 3.9)
endif()

# Plain and keyword target_link_libraries() signatures cannot be mixed
if (POLICY CMP0023)
  cmake_policy(SET CMP0023 NEW)
endif()

# Honor link flags in try_compile()
if (POLICY CMP0056)
  cmake_policy(SET CMP0056 NEW)
endif()

# only use the additional link flags when linking executables if the
# ENABLE_EXPORTS target property is set to True
if(POLICY CMP0065)
  cmake_policy(SET CMP0065 NEW)
endif()

# Honor language standard (CMAKE_CXX_STANDARD) in try_compile()
if(POLICY CMP0067)
  cmake_policy(SET CMP0067 NEW)
endif()

# Ignore generated source files in AUTOMOC and AUTOUIC
if(POLICY CMP0071)
  cmake_policy(SET CMP0071 OLD)
endif()

# Remove leading and trailing whitespace from libraries linked
if(POLICY CMP0004)
  cmake_policy(SET CMP0004 NEW)
endif()

# Use Boost-provided FindBoost module instead of CMake-provided one
if(POLICY CMP0167)
  cmake_policy(SET CMP0167 NEW)
endif()

# Normalize install(DESTINATION) paths
if(POLICY CMP0177)
  cmake_policy(SET CMP0177 NEW)
endif()

project(celestia VERSION 1.7.0 LANGUAGES C CXX)
set(DISPLAY_NAME "Celestia")
#
#
#
option(ENABLE_CELX        "Enable celx scripting, requires Lua library? (Default: on)" ON)
option(ENABLE_SPICE       "Use spice library? (Default: off)" OFF)
option(ENABLE_NLS         "Enable interface translation? (Default: on)" ON)
option(ENABLE_QT5         "Build Qt frontend? (Default: off)" OFF)
option(ENABLE_QT6         "Build Qt6 frontend (Default: off)" OFF)
option(ENABLE_SDL         "Build SDL frontend? (Default: off)" OFF)
option(ENABLE_WIN         "Build Windows native frontend? (Default: off)" OFF)
option(ENABLE_FFMPEG      "Support video capture using FFMPEG (Default: off)" OFF)
option(ENABLE_LIBAVIF     "Support avif textures (Default: off)" OFF)
option(ENABLE_MINIAUDIO   "Support audio playback using miniaudio (Default: off)" OFF)
option(ENABLE_TOOLS       "Build different tools? (Default: off)" OFF)
option(ENABLE_FAST_MATH   "Build with unsafe fast-math compiller option (Default: off)" OFF)
option(ENABLE_TESTS       "Enable unit tests? (Default: off)" OFF)
option(ENABLE_GLES        "Build for OpenGL ES 2.0 instead of OpenGL 2.1 (Default: off)" OFF)
option(ENABLE_LTO         "Enable link time optimizations (Default: off)" OFF)
option(USE_WAYLAND        "Use Wayland in Qt frontend (Default: off)" OFF)
option(USE_GLSL_STRUCTS   "Use structs in GLSL (Default: off)" OFF)
option(USE_ICU            "Use ICU for UTF8 decoding for text rendering (Default: off)" OFF)
option(USE_WIN_ICU        "Use Windows SDK's ICU implementation (Default: off)" OFF)
option(USE_MESHOPTIMIZER  "Use meshoptimizer (Default: off)" OFF)
option(USE_WEFFCPP        "Use the -Weffc++ option when compiling with GCC (Default: off)" OFF)
option(LEGACY_OPENGL_LIBS "Use legacy OpenGL libraries instead of glvnd library (Default: off)" OFF)

# Prefer GLVND or "legacy" OpenGL library (libOpenGL.so vs libGL.so)
if(LEGACY_OPENGL_LIBS)
  set(OpenGL_GL_PREFERENCE LEGACY)
else()
  set(OpenGL_GL_PREFERENCE GLVND)
endif()

# Qt requires -fPIC, so build all code with it
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(APPLE AND ENABLE_QT5 AND ENABLE_QT6)
  # If someone figures out how to resolve the include path conflicts, this can be removed
  message(FATAL_ERROR "Simultaneous builds of Qt5 and Qt6 are not supported on Apple systems")
endif()

if(ENABLE_GLES)
  add_definitions(-DGL_ES)
endif()

if(USE_GLSL_STRUCTS)
  # GLES SL on some old Android device or with ANGLE presents a link failure with empty error when using struct.
  # GLSL on old version of Mac OS X appears to have a bug that precludes us from using structs.
  add_definitions(-DUSE_GLSL_STRUCTS)
endif()

# Use our cmake files
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Require Windows 7
if(WIN32)
  set(WINVER 0x0601)
  set(NTDDI_VER 0x06010000)
endif()

if(USE_ICU)
  add_definitions(-DUSE_ICU)
  if(WIN32 AND USE_WIN_ICU)
    include(winicu)
    EnableWinICU()
  else()
    find_package(ICU REQUIRED COMPONENTS uc i18n)
    link_libraries(ICU::uc ICU::i18n)
  endif()
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type." FORCE)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(UNIX AND (NOT CYGWIN))
  set(_UNIX true)
endif()

# _USE_MATH_DEFINES enables use of math constants like M_PI,
# which are by default disabled in standard C++ mode (like std=c++11 instead of std=gnu11)
add_definitions(-D_USE_MATH_DEFINES)

# Let CMake handle setting C++11 (since 3.1)
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()
set(CMAKE_C_STANDARD 11)

if(NOT WIN32)
  include(GNUInstallDirs)
  include(rpath)
endif()
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(FastMath)

#
# Compile options
#
if(MSVC)
  # CMake 3.14 and below set warning flags by default, remove them to prevent conflicts
  string(REGEX REPLACE "/W[3|4]" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
  string(REGEX REPLACE "/W[3|4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  # Additional options
  # utf-8: set source and execution character set to UTF-8
  # bigobj: generate more object sections than allowed by default
  # Promoted to errors
  # C4316: object allocated on the heap may not be aligned 16
  add_compile_options("/utf-8" "/bigobj" "/we4316")

  if(MSVC_VERSION GREATER_EQUAL 1914)
    # /Zc:__cplusplus: correctly set __cplusplus macro value
    add_compile_options("/Zc:__cplusplus")
  endif()
endif()

if(MINGW)
  # MinGW has a bug which causes too many false-positive warnings
  # for 'operator!='
  add_compile_options(-Wno-attributes)
endif()

# G++ 10 introduced static analyzer
if(USE_WEFFCPP AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  string(REPLACE "." ";" GXX_VERSION_LIST ${CMAKE_CXX_COMPILER_VERSION})
  list(GET GXX_VERSION_LIST 0 MAJOR)
  if(MAJOR GREATER 9)
    add_compile_options($<$<COMPILE_LANGUAGE:CXX>:-Weffc++>)
  endif()
endif()

EnableFastMath(${ENABLE_FAST_MATH})

#
# NLS (Gettext) support
#
if(ENABLE_NLS)
  find_package(Gettext)
  if(NOT GETTEXT_FOUND)
    message(WARNING "Gettext is not found, translations won't be created.")
  endif()

  find_package(Intl REQUIRED)
  include(FixIntl)
  MakeIntlTarget()
  link_libraries(Intl::Intl)
  add_definitions(-DENABLE_NLS)
else()
  message(STATUS "NLS is disabled. Not looking for gettext and libintl.")
endif()

if(ENABLE_SPICE)
  find_package(CSPICE)
  if(NOT CSPICE_FOUND)
    message(STATUS "Using cspice submodule")
    add_subdirectory("${CMAKE_SOURCE_DIR}/thirdparty/Spice")
    get_target_property(SPICE_INCLUDE_DIR spice INCLUDE_DIRECTORIES)
    include_directories(${SPICE_INCLUDE_DIR})
    message(STATUS "Spice include directories: ${SPICE_INCLUDE_DIR}")
    add_library(CSPICE::CSPICE ALIAS spice)
  else()
    include_directories(${CSPICE_INCLUDE_DIR})
  endif()
  add_definitions(-DUSE_SPICE)
else()
  message(STATUS "NAIF SPICE is disabled. Not looking for cspice library.")
endif()

if(ENABLE_FFMPEG)
  include(FindFFMPEG)
  find_package(FFMPEG REQUIRED COMPONENTS avcodec avutil avformat swscale)
  link_libraries(FFMPEG::AVCODEC FFMPEG::AVUTIL FFMPEG::AVFORMAT FFMPEG::SWSCALE)
  add_definitions(-DUSE_FFMPEG)
endif()

if(ENABLE_MINIAUDIO)
  add_library(miniaudio INTERFACE)
  target_include_directories(miniaudio INTERFACE "${CMAKE_SOURCE_DIR}/thirdparty/miniaudio")

  if(UNIX AND (NOT APPLE))
    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)
    target_link_libraries(miniaudio INTERFACE Threads::Threads)
  endif()

  link_libraries(miniaudio)
  add_definitions(-DUSE_MINIAUDIO)
endif()

if(ENABLE_LIBAVIF)
  find_package(Libavif REQUIRED)
  link_libraries(libavif::libavif)
  include_directories(${LIBAVIF_INCLUDE_DIR})
  add_definitions(-DUSE_LIBAVIF)
endif()

if(_UNIX)
  find_package(PkgConfig)
endif()

if(WIN32)
  link_libraries("vfw32" "comctl32" "winmm")
endif()

if(ENABLE_WIN OR ENABLE_TOOLS)
  find_package(OpenGL REQUIRED)
endif()

find_package(Libepoxy REQUIRED)
link_libraries(libepoxy::libepoxy)
include_directories(${LIBEPOXY_INCLUDE_DIR})

find_package(Eigen3 3.3 REQUIRED NO_MODULE) # -DEigen3_DIR=...
message(STATUS "Found Eigen3 ${EIGEN3_VERSION_STRING}")
link_libraries(Eigen3::Eigen)

find_package(fmt 8.1.0 CONFIG QUIET)
if(NOT fmt_FOUND)
  message(STATUS "Using fmt submodule")
  add_subdirectory("${CMAKE_SOURCE_DIR}/thirdparty/fmt")
endif()
link_libraries(fmt::fmt)

find_package(PNG REQUIRED)
add_definitions(${PNG_DEFINITIONS})
link_libraries(PNG::PNG)

include(FixJPEG)
find_package(JPEG REQUIRED) # -DJPEG_LIBRARY=...
MakeJPEGTarget()
link_libraries(JPEG::JPEG)

if(ENABLE_CELX)
  add_definitions(-DCELX)

  find_package(LuaJIT)
  if(LUAJIT_FOUND)
    link_libraries(LuaJIT::LuaJIT)
  else()
    find_package(Lua REQUIRED)
    include(FixLua)
    MakeLuaTarget()
    link_libraries(Lua::Lua)
  endif()
else()
  message(STATUS "CELX is disabled. Not looking for LUA libraries.")
endif()

find_package(Freetype REQUIRED)
link_libraries(Freetype::Freetype)

if(USE_MESHOPTIMIZER)
  find_package(meshoptimizer CONFIG REQUIRED)
  set(HAVE_MESHOPTIMIZER 1)
endif()

if(USE_WAYLAND)
  message(STATUS "Creating Wayland protocol helpers")

  find_package(Wayland COMPONENTS protocols scanner REQUIRED)

  include(WaylandAddProtocolClient)
  wayland_add_protocol_client(PROTOCOL_SOURCES
    "unstable/pointer-constraints/pointer-constraints-unstable-v1.xml")
  wayland_add_protocol_client(PROTOCOL_SOURCES
    "unstable/relative-pointer/relative-pointer-unstable-v1.xml")

  set_source_files_properties(${PROTOCOL_SOURCES} PROPERTIES GENERATED ON)
  add_library(wayland-protocols-helper STATIC ${PROTOCOL_SOURCES})
  target_include_directories(wayland-protocols-helper INTERFACE ${CMAKE_CURRENT_BINARY_DIR})
endif()

find_package(gperf REQUIRED)

find_package(Boost REQUIRED)
link_libraries(Boost::boost)
add_definitions(-DBOOST_NO_EXCEPTIONS)

#[[
get_cmake_property(_variableNames VARIABLES)
list (SORT _variableNames)
foreach (_variableName ${_variableNames})
    message(STATUS "${_variableName}=${${_variableName}}")
endforeach()
]]#

if(WIN32)
  set(CMAKE_INSTALL_BINDIR ".")
  set(CMAKE_INSTALL_DATAROOTDIR ".")
  set(CMAKE_INSTALL_DATADIR ".")
  set(CMAKE_INSTALL_FULL_LOCALEDIR "locale")
  set(CMAKE_INSTALL_LOCALEDIR "${CMAKE_INSTALL_FULL_LOCALEDIR}")
  set(DATADIR "${CMAKE_INSTALL_DATADIR}")
  set(FULL_DATADIR ".")
else()
  set(DATADIR "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}")
  set(FULL_DATADIR "${CMAKE_INSTALL_FULL_DATADIR}/${PROJECT_NAME}")
endif()

if(NOT GIT_COMMIT)
  find_program(GIT_FOUND git)
  if(GIT_FOUND)
    execute_process(
      COMMAND git log --pretty=format:%h -1
      WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
      OUTPUT_VARIABLE GIT_COMMIT
    )
    if("${GIT_COMMIT}" STREQUAL "")
      set(GIT_COMMIT "unknown")
    endif()
  else()
    set(GIT_COMMIT "unknown")
  endif()
endif()

#
# Compile definitions
#
add_definitions(
  -DVERSION="${PROJECT_VERSION}"
  -DGIT_COMMIT="${GIT_COMMIT}"
)

add_definitions(
  -DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
  -DCONFIG_DATA_DIR="${FULL_DATADIR}"
  -DHIP_DATA_DIR="${FULL_DATADIR}"
)

if(WIN32)
  add_definitions(
    -D_CRT_SECURE_NO_WARNINGS
    -D_SCL_SECURE_NO_WARNINGS
    -DNOMINMAX
    -DWIN32_LEAN_AND_MEAN
    -DUNICODE
    -D_UNICODE
    -DWINVER=${WINVER}
    -D_WIN32_WINNT=${WINVER}
    -DNTDDI_VERSION=${NTDDI_VER}
  )
  # Fix the issue: https://github.com/CelestiaProject/Celestia/issues/364
  add_definitions(-D_ENABLE_EXTENDED_ALIGNED_STORAGE)
endif()

if(APPLE)
  add_definitions(-DGL_SILENCE_DEPRECATION)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" build_type_lc)
if("${build_type_lc}" STREQUAL "debug")
  add_definitions(-D_DEBUG -DDEBUG)
  if(NOT MSVC)
    add_compile_options("-fsanitize=address" "-fsanitize=undefined" "-fno-omit-frame-pointer")
    add_link_options("-fsanitize=address" "-fsanitize=undefined" "-fno-omit-frame-pointer")
  endif()
else()

=== src/celengine/CMakeLists.txt ===
set(CELENGINE_SOURCES
  asterism.cpp
  asterism.h
  astroobj.h
  atmosphere.h
  axisarrow.cpp
  axisarrow.h
  body.cpp
  body.h
  boundaries.cpp
  boundaries.h
  category.cpp
  category.h
  completion.cpp
  completion.h
  console.cpp
  console.h
  constellation.cpp
  constellation.h
  curveplot.cpp
  curveplot.h
  deepskyobj.cpp
  deepskyobj.h
  dsodb.cpp
  dsodb.h
  dsodbbuilder.cpp
  dsodbbuilder.h
  dsooctree.cpp
  dsooctree.h
  dsorenderer.cpp
  dsorenderer.h
  fisheyeprojectionmode.cpp
  fisheyeprojectionmode.h
  frame.cpp
  frame.h
  framebuffer.cpp
  framebuffer.h
  frametree.cpp
  frametree.h
  galaxy.cpp
  galaxy.h
  galaxyform.cpp
  galaxyform.h
  geometry.h
  glmarker.cpp
  globular.cpp
  globular.h
  glshader.cpp
  glshader.h
  glsupport.cpp
  glsupport.h
  lightenv.h
  location.cpp
  location.h
  lodspheremesh.cpp
  lodspheremesh.h
  mapmanager.cpp
  mapmanager.h
  marker.cpp
  marker.h
  meshmanager.cpp
  meshmanager.h
  modelgeometry.cpp
  modelgeometry.h
  multitexture.cpp
  multitexture.h
  name.cpp
  name.h
  nebula.cpp
  nebula.h
  objectrenderer.h
  observer.cpp
  observer.h
  octree.h
  octreebuilder.h
  opencluster.cpp
  opencluster.h
  orbitsampler.h
  overlay.cpp
  overlay.h
  overlayimage.cpp
  overlayimage.h
  parseobject.cpp
  parseobject.h
  perspectiveprojectionmode.cpp
  perspectiveprojectionmode.h
  planetgrid.cpp
  planetgrid.h
  pointstarrenderer.cpp
  pointstarrenderer.h
  pointstarvertexbuffer.cpp
  pointstarvertexbuffer.h
  projectionmode.cpp
  projectionmode.h
  rectangle.h
  referencemark.h
  rendcontext.cpp
  rendcontext.h
  render.cpp
  render.h
  renderflags.h
  renderglsl.cpp
  renderglsl.h
  renderinfo.h
  renderlistentry.h
  rotationmanager.cpp
  rotationmanager.h
  selection.cpp
  selection.h
  shadermanager.cpp
  shadermanager.h
  shared.h
  simulation.cpp
  simulation.h
  skygrid.h
  solarsys.cpp
  solarsys.h
  spheremesh.cpp
  spheremesh.h
  starbrowser.cpp
  starbrowser.h
  starcolors.cpp
  starcolors.h
  star.cpp
  star.h
  stardb.cpp
  stardb.h
  stardbbuilder.cpp
  stardbbuilder.h
  starname.cpp
  starname.h
  staroctree.cpp
  staroctree.h
  stellarclass.cpp
  stellarclass.h
  surface.h
  texmanager.cpp
  texmanager.h
  textlayout.cpp
  textlayout.h
  texture.cpp
  texture.h
  timeline.cpp
  timeline.h
  timelinephase.cpp
  timelinephase.h
  trajmanager.cpp
  trajmanager.h
  univcoord.h
  universe.cpp
  universe.h
  viewporteffect.h
  viewporteffect.cpp
  virtualtex.cpp
  virtualtex.h
  visibleregion.cpp
  visibleregion.h
)

add_library(celengine OBJECT ${CELENGINE_SOURCES})

gperf_add_table(celengine location.gperf location.cpp 4)
gperf_add_table(celengine solarsys.gperf solarsys.cpp 4)

=== src/celestia/CMakeLists.txt ===
set(CELESTIA_SOURCES
  catalogloader.h
  celestiacore.cpp
  celestiacore.h
  celestiastate.cpp
  celestiastate.h
  configfile.cpp
  configfile.h
  destination.cpp
  destination.h
  eclipsefinder.cpp
  eclipsefinder.h
  favorites.cpp
  favorites.h
  helper.cpp
  helper.h
  hud.cpp
  hud.h
  loaddso.cpp
  loaddso.h
  loadsso.cpp
  loadsso.h
  loadstars.cpp
  loadstars.h
  moviecapture.h
  scriptmenu.cpp
  scriptmenu.h
  textinput.cpp
  textinput.h
  textprintposition.cpp
  textprintposition.h
  timeinfo.h
  url.cpp
  url.h
  view.cpp
  view.h
  viewmanager.cpp
  viewmanager.h
  windowmetrics.cpp
  windowmetrics.h
)

if(ENABLE_FFMPEG)
  list(APPEND CELESTIA_SOURCES
    ffmpegcapture.cpp
    ffmpegcapture.h
  )
endif()

if(ENABLE_MINIAUDIO)
  list(APPEND CELESTIA_SOURCES
    audiosession.cpp
    audiosession.h
    miniaudiosession.h
  )

  set(MINIAUDIO_SOURCES
    miniaudiosession.cpp
  )

  # Files including miniaudio needs to treated as Objective-C++
  # on Apple platforms
  if(APPLE)
    set_property(SOURCE ${MINIAUDIO_SOURCES}
      APPEND_STRING PROPERTY COMPILE_FLAGS "-x objective-c++")
  endif()

  list(APPEND CELESTIA_SOURCES
    ${MINIAUDIO_SOURCES}
  )
endif()

set(CELESTIA_CORE_LIBS $<TARGET_OBJECTS:cel3ds>
                       $<TARGET_OBJECTS:celastro>
                       $<TARGET_OBJECTS:celengine>
                       $<TARGET_OBJECTS:celephem>
                       $<TARGET_OBJECTS:celimage>
                       $<TARGET_OBJECTS:celmath>
                       $<TARGET_OBJECTS:celmodel>
                       $<TARGET_OBJECTS:celrender>
                       $<TARGET_OBJECTS:celttf>
                       $<TARGET_OBJECTS:celutil>
)
if(TARGET celcompat)
  set(CELESTIA_CORE_LIBS ${CELESTIA_CORE_LIBS} $<TARGET_OBJECTS:celcompat>)
endif()

set(SCRIPT_LIBS $<TARGET_OBJECTS:celcommonscript> $<TARGET_OBJECTS:cellegacyscript>)
if(ENABLE_CELX)
  set(SCRIPT_LIBS ${SCRIPT_LIBS} $<TARGET_OBJECTS:celluascript>)
endif()

string(REPLACE "." ";" PROJECT_VERSION_LIST ${PROJECT_VERSION})
list(GET PROJECT_VERSION_LIST 0 PROJECT_VERSION_MAJOR)
list(GET PROJECT_VERSION_LIST 1 PROJECT_VERSION_MINOR)
set(CELSO "celestia-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")

add_library(celestia SHARED ${CELESTIA_SOURCES}
                            ${SCRIPT_LIBS}
                            ${CELESTIA_CORE_LIBS}
)

set_target_properties(celestia PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
  WINDOWS_EXPORT_ALL_SYMBOLS TRUE
)

if(ENABLE_SPICE)
  target_link_libraries(celestia CSPICE::CSPICE)
endif()

if(APPLE)
  target_link_libraries(celestia "-framework Foundation")
endif()

if(ENABLE_FFMPEG)
  target_link_libraries(celestia ${FFMPEG_LIBRARIES})
endif()

if(HAVE_MESHOPTIMIZER)
  target_link_libraries(celestia meshoptimizer::meshoptimizer)
endif()

if(ENABLE_LTO)
  set_target_properties(celestia PROPERTIES INTERPROCEDURAL_OPTIMIZATION ON)
endif()

if(WIN32)
  install(
    TARGETS celestia
    RUNTIME_DEPENDENCIES
      PRE_EXCLUDE_REGEXES "^api-ms" "^ext-ms-"
      POST_EXCLUDE_REGEXES ".*system32/.*\\.dll$"
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT core
  )
else()
  install(
    TARGETS celestia
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    NAMELINK_SKIP
    COMPONENT core
  )
endif()

add_subdirectory(qt5)
add_subdirectory(qt6)
add_subdirectory(sdl)
add_subdirectory(win32)

=== src/celutil/CMakeLists.txt ===
set(CELUTIL_SOURCES
  align.h
  array_view.h
  associativearray.cpp
  associativearray.h
  binaryread.h
  binarywrite.h
  blockarray.h
  bytes.h
  color.cpp
  color.h
  dateformatter.cpp
  dateformatter.h
  filetype.cpp
  filetype.h
  flag.h
  formatnum.cpp
  formatnum.h
  fsutils.cpp
  fsutils.h
  greek.cpp
  greek.h
  includeicu.h
  infourl.cpp
  infourl.h
  localeutil.h
  logger.cpp
  logger.h
  parser.cpp
  parser.h
  ranges.h
  r128.h
  r128util.cpp
  r128util.h
  reshandle.h
  resmanager.h
  stringutils.cpp
  stringutils.h
  strnatcmp.cpp
  strnatcmp.h
  timer.cpp
  timer.h
  tokenizer.cpp
  tokenizer.h
  tzutil.cpp
  tzutil.h
  uniquedel.h
  utf8.cpp
  utf8.h
  watcher.h
)

if (USE_ICU)
  list(APPEND CELUTIL_SOURCES
    unicode.cpp
    unicode.h
  )
endif()

if (WIN32)
  list(APPEND CELUTIL_SOURCES
    winutil.cpp
    winutil.h
  )
endif()

if (APPLE)
  list(APPEND CELUTIL_SOURCES
    appleutils.h
    appleutils.mm
  )
endif()

add_library(celutil OBJECT ${CELUTIL_SOURCES})

gperf_add_table(celutil parser.gperf parser.cpp 4)

=== test/unit/CMakeLists.txt ===
set(UNIT_TEST_SOURCES
  array_view_test.cpp
  associativearray_test.cpp
  category_test.cpp
  constellation_test.cpp
  greek_test.cpp
  kepler_test.cpp
  logger_test.cpp
  ranges_test.cpp
  stellarclass_test.cpp
  strnatcmp_test.cpp
  tokenizer_test.cpp)

#if(NOT HAVE_FLOAT_CHARCONV)
  list(APPEND UNIT_TEST_SOURCES charconv_compat_test.cpp)
#endif()

if(USE_ICU)
  list(APPEND UNIT_TEST_SOURCES unicode_test.cpp)
else()
  list(APPEND UNIT_TEST_SOURCES formatnum_test.cpp)
endif()

if(WIN32)
  list(APPEND UNIT_TEST_SOURCES winutil_test.cpp)
endif()

test_case(unit "${UNIT_TEST_SOURCES}")

=== thirdparty/Spice/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19.2)
project(Spice)

# Include all *.c files from the library
file(GLOB SPICE_COMMON_SOURCE ${PROJECT_SOURCE_DIR}/src/common/*.c)
set(INCLUDE_PATH "${PROJECT_SOURCE_DIR}/include")

if (MSVC)
  file(GLOB SPICE_PLATFORM_SOURCE ${PROJECT_SOURCE_DIR}/src/msvc/*.c)
  set(INCLUDE_PATH "${PROJECT_SOURCE_DIR}/include/msvc" ${INCLUDE_PATH})
elseif (APPLE)
  # Detection code adapted from
  # https://github.com/Kitware/CMake/blob/master/Modules/CMakeDetermineSystem.cmake
  if (DEFINED CMAKE_APPLE_SILICON_PROCESSOR)
    set(_CMAKE_APPLE_SILICON_PROCESSOR "${CMAKE_APPLE_SILICON_PROCESSOR}")
  elseif(DEFINED ENV{CMAKE_APPLE_SILICON_PROCESSOR})
    set(_CMAKE_APPLE_SILICON_PROCESSOR "$ENV{CMAKE_APPLE_SILICON_PROCESSOR}")
  else()
    set(_CMAKE_APPLE_SILICON_PROCESSOR "")
  endif()
  
  if (_CMAKE_APPLE_SILICON_PROCESSOR STREQUAL "arm64")
    file(GLOB SPICE_PLATFORM_SOURCE ${PROJECT_SOURCE_DIR}/src/mac_arm/*.c)
    set(INCLUDE_PATH "${PROJECT_SOURCE_DIR}/include/mac_arm" ${INCLUDE_PATH})
  else ()
    file(GLOB SPICE_PLATFORM_SOURCE ${PROJECT_SOURCE_DIR}/src/mac/*.c)
    set(INCLUDE_PATH "${PROJECT_SOURCE_DIR}/include/mac" ${INCLUDE_PATH})
  endif()
elseif (CYGWIN)
  file(GLOB SPICE_PLATFORM_SOURCE ${PROJECT_SOURCE_DIR}/src/cygwin/*.c)
  set(INCLUDE_PATH "${PROJECT_SOURCE_DIR}/include/cygwin" ${INCLUDE_PATH})
elseif (MINGW)
  # Untested
  file(GLOB SPICE_PLATFORM_SOURCE ${PROJECT_SOURCE_DIR}/src/linux/*.c)
  set(INCLUDE_PATH "${PROJECT_SOURCE_DIR}/include/linux" ${INCLUDE_PATH})
elseif (UNIX)
  file(GLOB SPICE_PLATFORM_SOURCE ${PROJECT_SOURCE_DIR}/src/linux/*.c)
  set(INCLUDE_PATH "${PROJECT_SOURCE_DIR}/include/linux" ${INCLUDE_PATH})
endif ()

option(SPICE_BUILD_SHARED_LIBRARY "Build SPICE library as shared library" ON)

if (SPICE_BUILD_SHARED_LIBRARY)
  add_library(spice SHARED ${SPICE_COMMON_SOURCE} ${SPICE_PLATFORM_SOURCE})
else ()
  add_library(spice STATIC ${SPICE_COMMON_SOURCE} ${SPICE_PLATFORM_SOURCE})
endif ()
set_target_properties(spice PROPERTIES POSITION_INDEPENDENT_CODE 1)
set_target_properties(spice PROPERTIES C_STANDARD 90)
target_include_directories(spice PUBLIC "${INCLUDE_PATH}")

if (WIN32)
  # Our compile definitions on Windows
  # We are not manually setting the optimization level, but leave that to the Debug/Release flags
  target_compile_definitions(spice PRIVATE 
    _COMPLEX_DEFINED
    MSDOS
    OMIT_BLANK_CC
    NON_ANSI_STDIO
  )
  target_compile_options(spice PRIVATE /MP)

  set_target_properties(spice PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
else ()
  target_compile_definitions(spice PRIVATE NON_ANSI_STDIO)
  target_compile_options(spice PRIVATE -ansi)
endif ()

if (MSVC)
  target_compile_options(spice PRIVATE /W0)
else ()
  target_compile_options(spice PRIVATE -w)
endif ()

if (WIN32)
  target_precompile_headers(spice PRIVATE
    <math.h>
    <string.h>
    <stdlib.h>
    [["f2c.h"]]
    [["SpiceUsr.h"]]
    [["SpiceZfc.h"]]
    [["SpiceZpr.h"]]
    [["SpiceZst.h"]]
    [["SpiceZmc.h"]]
  )
endif ()

=== src/celestia/qt6/CMakeLists.txt ===
if(NOT ENABLE_QT6)
  message(STATUS "Qt6 frontend is disabled.")
  return()
endif()

include(../qt/CelestiaQtCommon.cmake)

# Instruct CMake to run moc automatically when needed
set(CMAKE_AUTOMOC ON)
# Create code from a list of Qt designer ui files
set(CMAKE_AUTOUIC ON)

find_package(Qt6 COMPONENTS Core Widgets OpenGLWidgets CONFIG REQUIRED)
qt6_add_resources(RC_SRC "../qt/icons.qrc")

if(USE_WAYLAND)
  GetQtSources(ON)
else()
  GetQtSources(OFF)
endif()

add_executable(celestia-qt6 WIN32 ${QT_SOURCES} ${RES} ${RC_SRC})
add_dependencies(celestia-qt6 celestia)
target_link_libraries(celestia-qt6 Qt6::Widgets Qt6::OpenGLWidgets celestia)

if(USE_WAYLAND)
  target_link_libraries(celestia-qt6 Wayland::Client wayland-protocols-helper)
  target_compile_definitions(celestia-qt6 PRIVATE USE_WAYLAND)
  target_include_directories(celestia-qt6 PRIVATE ${Qt6Gui_PRIVATE_INCLUDE_DIRS})
endif()

set_target_properties(celestia-qt6 PROPERTIES CXX_VISIBILITY_PRESET hidden)

if(APPLE)
  set_property(TARGET celestia-qt6 APPEND_STRING PROPERTY LINK_FLAGS " -framework CoreFoundation")
  set_property(TARGET celestia-qt6 APPEND_STRING PROPERTY LINK_FLAGS " -framework CoreServices")
endif()

if(WIN32)
  install(
    TARGETS celestia-qt6
    RUNTIME_DEPENDENCIES
      PRE_EXCLUDE_REGEXES "^api-ms" "^ext-ms-"
      POST_EXCLUDE_REGEXES ".*system32/.*\\.dll$"
      DIRECTORIES $<TARGET_FILE_DIR:celestia> $<TARGET_FILE_DIR:Qt6::Core>
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT qt6gui
  )
else()
  install(
    TARGETS celestia-qt6
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT qt6gui
  )
endif()

if(ENABLE_LTO)
  set_target_properties(celestia-qt6 PROPERTIES INTERPROCEDURAL_OPTIMIZATION ON)
endif()

if(WIN32)
  qt6_generate_deploy_app_script(TARGET celestia-qt6
    OUTPUT_SCRIPT deploy-celestia-qt6
    NO_UNSUPPORTED_PLATFORM_ERROR
    NO_COMPILER_RUNTIME
    NO_TRANSLATIONS
  )
  install(
    SCRIPT ${deploy-celestia-qt6}
    COMPONENT qt6gui
  )
endif()

add_subdirectory(data)

=== src/celestia/sdl/CMakeLists.txt ===
if(NOT ENABLE_SDL)
  message(STATUS "SDL frontend is disabled.")
  return()
endif()

find_package(SDL2 CONFIG REQUIRED)

set(IMGUI_DIR "${PROJECT_SOURCE_DIR}/thirdparty/imgui")

set(IMGUI_SOURCES
    "${IMGUI_DIR}/imconfig.h"
    "${IMGUI_DIR}/imgui_demo.cpp"
    "${IMGUI_DIR}/imgui_draw.cpp"
    "${IMGUI_DIR}/imgui_internal.h"
    "${IMGUI_DIR}/imgui_tables.cpp"
    "${IMGUI_DIR}/imgui_widgets.cpp"
    "${IMGUI_DIR}/imgui.cpp"
    "${IMGUI_DIR}/imgui.h"
    "${IMGUI_DIR}/imstb_rectpack.h"
    "${IMGUI_DIR}/imstb_textedit.h"
    "${IMGUI_DIR}/imstb_truetype.h"
    "${IMGUI_DIR}/backends/imgui_impl_opengl3.cpp"
    "${IMGUI_DIR}/backends/imgui_impl_opengl3.h"
    "${IMGUI_DIR}/backends/imgui_impl_sdl2.cpp"
    "${IMGUI_DIR}/backends/imgui_impl_sdl2.h"
    "${IMGUI_DIR}/misc/cpp/imgui_stdlib.cpp"
    "${IMGUI_DIR}/misc/cpp/imgui_stdlib.h")

add_library(imgui STATIC ${IMGUI_SOURCES})
target_include_directories(imgui PUBLIC "${IMGUI_DIR}" "${IMGUI_DIR}/backends" "${IMGUI_DIR}/misc/cpp")

set(SDL_SOURCES
    aboutdialog.cpp
    aboutdialog.h
    appwindow.cpp
    appwindow.h
    clipboard.cpp
    clipboard.h
    environment.cpp
    environment.h
    glcontext.cpp
    glcontext.h
    gui.cpp
    gui.h
    helpers.h
    objectsdialog.cpp
    objectsdialog.h
    renderdialog.cpp
    renderdialog.h
    sdlmain.cpp
    settings.cpp
    settings.h
    timedialog.cpp
    timedialog.h)

add_executable(celestia-sdl ${SDL_SOURCES})

gperf_add_table(celestia-sdl settings.gperf settings.cpp 4)

add_dependencies(celestia-sdl celestia)
target_link_libraries(celestia-sdl PRIVATE imgui celestia)

set_target_properties(celestia-sdl PROPERTIES CXX_VISIBILITY_PRESET hidden)

if(TARGET SDL2::SDL2main AND TARGET SDL2::SDL2)
  if(MINGW)
    target_compile_definitions(celestia-sdl PRIVATE SDL_MAIN_HANDLED)
  endif()
  target_link_libraries(celestia-sdl PRIVATE SDL2::SDL2main SDL2::SDL2)
  target_link_libraries(imgui PUBLIC SDL2::SDL2)
else()
  target_include_directories(celestia-sdl PRIVATE ${SDL2_INCLUDE_DIRS})
  target_link_libraries(celestia-sdl PRIVATE ${SDL2_LIBRARIES})
  target_link_libraries(imgui PUBLIC ${SDL2_LIBRARIES})
endif()

install(
  TARGETS celestia-sdl
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT sdlgui
)

add_subdirectory(data)

=== src/tools/celestia-gaia-stardb/requirements.txt ===
Arpeggio==1.10.2
astroid==2.9.0
astropy==5.0
astropy-healpix==0.6
astroquery==0.4.4
beautifulsoup4==4.10.0
certifi==2021.10.8
cffi==1.15.0
charset-normalizer==2.0.9
cryptography==36.0.1
html5lib==1.1
idna==3.3
importlib-metadata==4.9.0
isort==5.10.1
jeepney==0.7.1
keyring==23.4.0
lazy-object-proxy==1.7.1
maturin==0.12.4
mccabe==0.6.1
numpy==1.21.4
packaging==21.3
platformdirs==2.4.0
pycparser==2.21
pyerfa==2.0.0.1
pylint==2.12.2
pyparsing==3.0.6
pyvo==1.2
PyYAML==6.0
requests==2.26.0
SecretStorage==3.3.1
six==1.16.0
soupsieve==2.3.1
toml==0.10.2
typing_extensions==4.0.1
urllib3==1.26.7
webencodings==0.5.1
wrapt==1.13.3
zipp==3.6.0

=== debian/changelog ===
celestia (1.7.0~git20250418+fab96cc-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Disable the Qt 6 version.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 24 Apr 2025 10:28:45 -0700

celestia (1.7.0~git20190807+d9746691+0) UNRELEASED; urgency=medium

  * New snapshot build

 -- Hleb Valoshka <375gnu@gmail.com>  Wed, 07 Aug 2019 18:47:48 +0300

celestia (1.6.1+dfsg-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix mips64(el) build: don't use mips as variable name (Closes: 754266).

 -- YunQiang Su <syq@debian.org>  Thu, 16 Oct 2014 18:21:52 +0800

=== debian/control ===
Source: celestia
Section: science
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Hleb Valoshka <375gnu@gmail.com>
Build-Depends: chrpath,
               cmake (>= 3.1~),
               debhelper (>= 10~),
               gperf,
               libavcodec-dev,
               libavformat-dev,
               libavif-dev,
               libavutil-dev,
               libboost-dev,
               libeigen3-dev (>= 3.3~),
               libepoxy-dev,
               libfmt-dev,
               libfreetype6-dev,
               libglu1-mesa-dev,
               libicu-dev,
               libjpeg62-turbo-dev | libjpeg-dev,
               libluajit-5.1-dev,
               libpng-dev (>= 1.6) | libpng16-dev,
               libqt5opengl5-dev,
               libsdl2-dev,
               libswscale-dev,
               libwayland-dev,
               ninja-build,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtbase5-private-dev,
               wayland-protocols
Standards-Version: 4.0.0
Homepage: https://github.com/CelestiaProject/Celestia

Package: celestia-common
Architecture: all
Conflicts: celestia (<< 1.4.1), celestia-common (<< 1.7.0~)
Replaces: celestia (<< 1.4.1), celestia-common (<< 1.7.0~)
Depends: fonts-dejavu-core, ${misc:Depends}
Description: common files for Celestia, a real-time visual space simulation
 Celestia is a free 3D astronomy program. Based on the Hipparcos
 Catalogue, it allows users to display objects ranging in scale from
 artificial satellites to entire galaxies in three dimensions using
 OpenGL. Unlike most planetarium software, the user is free to travel
 about the Universe.
 .
 This package contains the files common for all Celestia frontends.

Package: celestia
Architecture: all
Depends: celestia-qt5 | celestia-sdl, ${misc:Depends}
Description: real-time visual space simulation
 Celestia is a free 3D astronomy program. Based on the Hipparcos
 Catalogue, it allows users to display objects ranging in scale from
 artificial satellites to entire galaxies in three dimensions using
 OpenGL. Unlike most planetarium software, the user is free to travel
 about the Universe.
 .
 This is a dummy package that selects at least one frontend for Celestia.

Package: celestia-qt5
Section: science
Architecture: any
Depends: celestia-common (= ${binary:Version}),
         celestia-data (>= 1.7.0~),
         libcelestia1.7 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: celestia (<< 1.4.1)
Replaces: celestia (<< 1.4.1)
Suggests: stellarium
Description: real-time visual space simulation (Qt5 frontend)
 Celestia is a free 3D astronomy program. Based on the Hipparcos
 Catalogue, it allows users to display objects ranging in scale from
 artificial satellites to entire galaxies in three dimensions using
 OpenGL. Unlike most planetarium software, the user is free to travel
 about the Universe.
 .
 This package contains the Qt5 frontend for Celestia.

Package: celestia-sdl
Architecture: any
Depends: celestia-common (= ${binary:Version}),
         celestia-data (>= 1.7.0~),
         libcelestia1.7 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: celestia (<< 1.4.1)
Replaces: celestia (<< 1.4.1)
Suggests: stellarium
Description: real-time visual space simulation (SDL frontend)
 Celestia is a free 3D astronomy program. Based on the Hipparcos
 Catalogue, it allows users to display objects ranging in scale from
 artificial satellites to entire galaxies in three dimensions using
 OpenGL. Unlike most planetarium software, the user is free to travel
 about the Universe.
 .
 This package contains the SDL frontend for Celestia.

Package: libcelestia1.7
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: tzdata
Description: Library for the Celestia space simulator
 This package includes the libcelestia library, which is
 necessary to run Celestia.

Package: celestia-tools
Architecture: any
Depends: libcelestia1.7 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: celestia (<< 1.4.1)
Replaces: celestia (<< 1.4.1)
Suggests: stellarium
Description: real-time visual space simulation (tools)
 Celestia is a free 3D astronomy program. Based on the Hipparcos
 Catalogue, it allows users to display objects ranging in scale from
 artificial satellites to entire galaxies in three dimensions using
 OpenGL. Unlike most planetarium software, the user is free to travel
 about the Universe.
 .
 This package contains tools required to create data files for Celestia.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	if echo "$(DEB_VERSION)" | grep -q '~git' ; then \
		_git_commit=$$(echo "$(DEB_VERSION)" | cut -d'+' -f2 | cut -d'-' -f1) ; \
	else \
		_git_commit="unknown" ; \
	fi ; \
	dh_auto_configure --parallel -- \
		-GNinja					\
		-DCMAKE_BUILD_TYPE=RelWithDebInfo	\
		-DENABLE_FFMPEG=ON			\
		-DENABLE_MINIAUDIO=ON			\
		-DUSE_ICU=ON				\
		-DENABLE_QT5=ON				\
		-DUSE_WAYLAND=ON			\
		-DENABLE_SDL=ON				\
		-DENABLE_SPICE=ON			\
		-DSPICE_BUILD_SHARED_LIBRARY=OFF	\
		-DENABLE_TESTS=OFF			\
		-DENABLE_TOOLS=ON			\
		-DENABLE_LTO=ON				\
		-DENABLE_LIBAVIF=ON			\
		-DENABLE_WIN=OFF			\
		-DGIT_COMMIT="$$_git_commit"


override_dh_auto_build:
	ninja -v -C obj-$(DEB_HOST_GNU_TYPE)


#override_dh_auto_test:
#	cd obj-$(DEB_HOST_GNU_TYPE) && ctest --output-on-failure


override_dh_install:
	cp -p obj-$(DEB_HOST_GNU_TYPE)/src/tools/spice2xyzv/spice2xyzv debian/tmp/usr/bin/
	find debian/tmp/usr/bin/ -type f ! -name *.pl -exec chrpath --delete {} ';'
	chrpath --delete debian/tmp/usr/lib/*/libcelestia.so.*
	dh_install
	dh_missing --fail-missing
	mv debian/celestia-common/usr/share/celestia/celestia.cfg \
	   debian/celestia-common/etc/celestia.cfg
	ln -s /etc/celestia.cfg debian/celestia-common/usr/share/celestia/
	rm debian/celestia-common/usr/share/celestia/fonts/*
	ln -s /usr/share/fonts/truetype/dejavu/DejaVuSans.ttf \
	      debian/celestia-common/usr/share/celestia/fonts/
	ln -s /usr/share/fonts/truetype/dejavu/DejaVuSans-Bold.ttf \
	      debian/celestia-common/usr/share/celestia/fonts/


override_dh_auto_install:
	env DESTDIR=$(shell pwd)/debian/tmp ninja -v -C obj-$(DEB_HOST_GNU_TYPE) install

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym
